Attribute VB_Name = "MCES_Connection"
Public MCPacket As New MCES_Packet

Public Sub SendAccountLogon(Username As String, Password As String)
    With MCPacket
        .InsertCString Username
        .InsertCString Password
        .SendPacket ID_ACCOUNTLOGON
    End With
End Sub

Public Sub SendRequestIP(Username As String)
    With MCPacket
        .InsertCString Username
        .SendPacket ID_REQUESTIP
    End With
End Sub

Public Sub HandleIPQuery()
    Dim m As VbMsgBoxResult
    m = MsgBox("Do you want to allow " & MCPacket.GetCString & " to connect to you?", vbQuestion + vbYesNo, "MCES Instant Message")
    If m = vbYes Then
        MCPacket.InsertByte 1
        MCPacket.SendPacket ID_IPQUERY
    Else
        MCPacket.InsertByte 0
        MCPacket.SendPacket ID_IPQUERY
    End If
End Sub

Public Sub HandleRequestIP()
    With MCPacket
        If .GetByte = 1 Then
            Dim IPAddress As String
            IPAddress = .GetByte & "." & .GetByte & "." & .GetByte & "." & .GetByte
            Dim j As New frmIM
            j.Show
            j.wsClient.Close
            j.wsClient.Connect IPAddress, 33345
            j.You = frmMain.txtUsername.Text
            j.Them = .GetCString
        Else
            MsgBox "Failed to get IPAddress"
        End If
    End With
End Sub

Public Sub SendAccountUserAction(Action As Long, Username As String, Optional Client As String, Optional Server As String)
    With MCPacket
        .InsertDWORD Action
        .InsertCString Username
        If Len(Client) > 0 Then .InsertCString Client
        If Len(Server) > 0 Then .InsertCString Server
        .SendPacket ID_ACCOUNTUSERACTION
    End With
End Sub

Public Sub HandleMailReceived()
    Funct.AddChat Active, vbCyan, "MCES: Mail has just been received!"
    SendMailGet
End Sub

Public Sub HandleMail()
    Select Case MCPacket.GetByte
        Case IDM_READ
            With MCPacket
                frmMail.Show
                frmMail.lvMail.ListItems.Clear
                Dim iLoop As Integer
                For iLoop = 1 To .GetDWORD
                    frmMail.lvMail.ListItems.Add(, , .GetCString).ListSubItems.Add , , .GetCString
                Next
            End With
        Case IDM_ADD
            If MCPacket.GetByte = 1 Then Funct.AddChat Active, vbCyan, "MCES: " & "Failed to add mail!"
        Case IDM_COUNT
            Funct.AddChat Active, vbCyan, "MCES: " & MCPacket.GetDWORD & " items in your inbox!"
    End Select
End Sub

Public Sub SendMailGet()
    With MCPacket
        .InsertByte IDM_READ
        .SendPacket ID_MAIL
    End With
End Sub

Public Sub SendMailAdd(Username As String, Message As String)
    With MCPacket
        .InsertByte IDM_ADD
        .InsertCString Username
        .InsertCString Message
        .SendPacket ID_MAIL
    End With
End Sub

Public Sub SendMailCount()
    With MCPacket
        .InsertByte IDM_COUNT
        .SendPacket ID_MAIL
    End With
End Sub

Public Sub SendMailEmpty()
    With MCPacket
        .InsertByte IDM_EMPTY
        .SendPacket ID_MAIL
    End With
End Sub

Public Sub HandleAccountLogon()
    If MCPacket.GetDWORD = 0 Then
        frmMain.MCESConnected = True
        frmMain.mces_Status.Caption = vbNullString
        SendMailCount
    Else
        frmMain.mces_Status.Caption = "Err: Invalid Account or Password"
        frmMain.MCESConnected = False
    End If
End Sub

Public Sub HandleAccountAdd()
    Dim Username As String
    Username = MCPacket.GetCString
    If Len(Username) > 0 Then
        Dim i As Integer
        For i = frmMain.lvMirage.ListItems.Count To 1 Step -1
            If LCase$(frmMain.lvMirage.ListItems.Item(i).Text) = LCase$(Username) Then
                frmMain.lvMirage.ListItems.Remove i
            End If
        Next
        frmMain.lvMirage.ListItems.Add , , Username
    End If
End Sub

Public Sub HandleUserAdd()
    Dim Username As String
    Username = MCPacket.GetCString
    If Len(Username) > 0 Then
        Dim i As Integer
        For i = frmMain.lvMirageUsers.ListItems.Count To 1 Step -1
            If LCase$(frmMain.lvMirageUsers.ListItems.Item(i).Text) = LCase$(Username) Then
                frmMain.lvMirageUsers.ListItems.Remove i
            End If
        Next
        frmMain.lvMirageUsers.ListItems.Add , , Username, , GetClientIcon(StrReverse(MCPacket.GetCString), 0)
    End If
End Sub

Public Sub HandleAccountRem()
    Dim Username As String
    Username = MCPacket.GetCString
    If Len(Username) > 0 Then
        Dim i As Integer
        For i = frmMain.lvMirage.ListItems.Count To 1 Step -1
            If LCase$(frmMain.lvMirage.ListItems.Item(i).Text) = LCase$(Username) Then
                frmMain.lvMirage.ListItems.Remove i
            End If
        Next
    End If
End Sub

Public Sub HandleAccountList()
    frmMain.lvMirage.ListItems.Clear
    Dim lCount As Long, lLoop As Long
    lCount = MCPacket.GetDWORD
    For lLoop = 1 To lCount
        frmMain.lvMirage.ListItems.Add , , MCPacket.GetCString
    Next
End Sub

Public Sub HandleUserList()
    frmMain.lvMirageUsers.ListItems.Clear
    Dim lCount As Long, lLoop As Long
    lCount = MCPacket.GetDWORD
    For lLoop = 1 To lCount
        frmMain.lvMirageUsers.ListItems.Add , , MCPacket.GetCString, , GetClientIcon(StrReverse(MCPacket.GetCString), 0)
        Dim temp As String
        temp = MCPacket.GetCString
    Next
End Sub


